using System;
using System.Collections.Generic;
using System.Reflection;

public class CustomerManager : ICustomerManager
{
	private SortedList<int, ICustomer> customers;
    private int nextIndex = 1;

	public CustomerManager()
	{
		customers = new SortedList<int, ICustomer>();
	}

	public ICustomer AddCustomer(string name)
	{
		Customer customer =  new Customer(name);
        customers.Add(nextIndex, customer);
        customer.Id = nextIndex;
        nextIndex++;
        return customer;
	}

	public void RemoveCustomer(ICustomer customer)
	{
        customers.Remove(customer.Id);
	}

	public ICustomer GetCustomer(string name)
	{
        ICustomer customer = null;

        foreach (KeyValuePair<int, ICustomer> pair in customers)
        {
            if (pair.Value.Name == name)
            {
                customer = pair.Value;
                break;
            }
        }

		return customer;
	}

	public ICustomer GetCustomer(int id)
	{
        ICustomer customer = null;
        customers.TryGetValue(id, out customer);
        return customer;
	}

	public IList<ICustomer> GetCustomers()
	{
        List<ICustomer> list = new List<ICustomer>();

        foreach (KeyValuePair<int, ICustomer> pair in customers)
            list.Add(pair.Value);
            
		return list;
	}
}