using System;
using System.Collections.Generic;

class Test
{
	static void Main()
	{
		try
		{
			ICustomerManager icm = CustomerManagerFactory.CreateCustomerManager();

			ICustomer customer1 = icm.AddCustomer("Harry");
			ICustomer customer2 = icm.AddCustomer("John");
			ICustomer customer3 = icm.AddCustomer("Mary");

			ICustomer iCust = icm.GetCustomer("John");
			Console.WriteLine("Retrieve By Name: Customer {0} has id {1}", iCust.Name, iCust.Id);

			iCust = icm.GetCustomer(customer3.Id);
			Console.WriteLine("Retrieve By Id: Customer {0} has id {1}", iCust.Name, iCust.Id);

			Console.WriteLine("CustomerList");
            IList<ICustomer> list = icm.GetCustomers();
			foreach (ICustomer ic in list)
				Console.WriteLine("    Customer {0} has id {1}", ic.Name, ic.Id);

		}
		catch(Exception e)
		{
			Console.WriteLine(e.Message);
		}
	}

	
}
